package opm;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class OpenPitMining {

	/**
	 * @param args
	 */
	int[] arg;
	int[][] table;
	/*
	 * Constructor
	 */
	public OpenPitMining(){
		try {
			//String path = getClass().getResource("test.txt").toString().substring(5).replaceAll("%20", " ");
			String path = "C:\\Users\\Onur\\Desktop\\TestProjects\\OpenPitMining_Berker_Soyluoglu\\Open Pit Mining\\test.txt";
			//System.out.println(path);
			Scanner sc = new Scanner(new File(path));
			//Read file from disk	
			//Create a scanner object for file IO
			String input = sc.nextLine();
			//Read the file
			String inputString[] = input.split(" ");
			//Separate string into array with the regular expression of " " black space
			arg = new int[inputString.length];
			table = new int[inputString.length][inputString.length];
			
			for (int i = 0; i < inputString.length; i++) {
				arg[i] = Integer.valueOf(inputString[i]);
				// Cast each element into integer
			}
			
		} catch (FileNotFoundException e) {// File not found
			e.printStackTrace();
		}
	}

	public void solve(){

		for(int mm=0;mm<200;mm++)
		{
		int max= Integer.MIN_VALUE;
		table[0][0] = arg[0]; // Create lookuptable

		for (int i = 0; i < arg.length; i++) {// Starting point of additions
			for (int j = i; j < arg.length; j++) {// Current ending point of additions
				if(j == 0)// first sum starting from 0 to 0
				{
					table[i][j] = arg[j];
				}else if(i==0){// Summing the first row of the table starting from 0 to j
					table[i][j] = table[i][j-1] + arg[j];
				}else{// Use table to calculate the sums starting from i !=0
					table[i][j] = table[i-1][j] - arg[i-1];
				}
				if(max< table[i][j])
					max = table[i][j];
			}
		}
		}
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		OpenPitMining pit = new OpenPitMining();
		System.out.println("I'm Memoization");
		long x = System.currentTimeMillis();// Get System Time used for real time analysis
		pit.solve(); // Solve
		
		
		
		
		long y = System.currentTimeMillis();// Finish time
		
		System.out.println("total time "+ (y-x));// Total time calculating

	}

}
